{.$DEFINE WRITELANG}//Write default.ini with language?
unit CmdLineHelp;

interface

uses
  Forms,
  StdCtrls,
  OffBtn,
  Controls,
  Classes,
  Translator;

type
  TCmdLineHelpForm = class(TForm)
    HelpMemo: TMemo;
    CloseButton: TOffice97Button;
    Translator: TTranslator;
    procedure FormCreate(Sender: TObject);
    procedure CloseButtonClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure TranslatorAfterTranslation(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  CmdLineHelpForm: TCmdLineHelpForm;
  CalledFromCodeConv: Integer;

implementation
uses CodeConvTools,
  SysUtils,
  CommonData;

{$R *.DFM}

procedure TCmdLineHelpForm.FormCreate(Sender: TObject);
begin
  TranslatorAfterTranslation(Sender);
end;

procedure TCmdLineHelpForm.CloseButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TCmdLineHelpForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key in [' ', #13, #10, #27] then Close;
end;

procedure TCmdLineHelpForm.FormShow(Sender: TObject);
begin
  Translator.RootComponent := Self;
  Translator.UseEmpty := False;
  Translator.AddRootName := True;
{$IFDEF WRITELANG}

  Translator.LanguageFile := ExtractFilePath(ParamStr(0)) + DefaultLanguageFile;
  Translator.CreateIniFile;

{$ENDIF}
  if FileExists(ExtractFilePath(ParamStr(0)) + LanguageFile) then
  begin
    Translator.LanguageFile := ExtractFilePath(ParamStr(0)) + LanguageFile;
    Translator.Translate;
  end;
end;

procedure TCmdLineHelpForm.TranslatorAfterTranslation(Sender: TObject);
var
  s1, s2: string;
begin
  if CalledFromCodeConv = 1 then
  begin
    s1 := AppName + ' ';
    s2 := '';
  end
  else
  begin
    s1 := 'CC ';
    s2 := ' - ' + AppName + ' ' + Translator.TranslateUserMessage('CommandLineHandler', 'command line handling program');
  end;
  HelpMemo.Lines[0] := s1 + Translator.TranslateUserMessage('Version', 'version') + ' ' + VersionString + '' + s2;
  HelpMemo.Lines[1] := AppCopyright + ' <' + AuthorEmail + '>';
  HelpMemo.Lines[3] :=
    Format(Translator.TranslateUserMessage('PartOf', 'This program is part of %0:s and is used by %1:s components.'), [AppVerName, AppName]);
  HelpMemo.Lines[5] := s1 + '/x [/Fx] [/En] [/Cy] [/Q|/Qz] ' +
    Translator.TranslateUserMessage('SourceFileName', 'sourcefilename') + ' [' +
    Translator.TranslateUserMessage('TargetFileName', 'targetfilename') + '|/O]';
  Caption:=AppName + ' '+Translator.TranslateUserMessage('Version', 'version') + ' ' + VersionString+' - '+ Translator.TranslateUserMessage('CmdLineHelp', 'command line help');
end;

end.

