program CodeConv;

uses
  Forms,
  Windows,
  Dialogs,
  SysUtils,
  Main in 'Main.pas' {CodeConvMainForm},
  Options in 'Options.pas' {OptionsForm},
  CodeConvTools,
  Registry,
  Translator,
  EasterEgg in 'EasterEgg.pas' {EasterEggForm},
  CommonData in 'CommonData.pas';

{$R *.RES}

function GetCommandLine: PChar; stdcall;
  external 'kernel32.dll' Name 'GetCommandLineA';

procedure WorkWithParams;
var
  CommandLine: string;
  Transl: TTranslator;
  Path: string;
begin
  Path := ExtractFilePath(ParamStr(0));
  if not (FileExists(Path + 'cc.exe')) then
  begin
    Transl := TTranslator.Create(Application);
    if FileExists(Path + LanguageFile) then
    begin
      Transl.LanguageFile := Path + LanguageFile;
      Transl.UseEmpty := False;
    end;
    Transl.ShowMessage(Transl.TranslateUserMessage('CCNotFound', 'Program CC.exe not found, to use command line you need to install it.'));
    Transl.Free;
  end;
  CommandLine := GetCommandLine;
  CommandLine := Path + 'cc.exe codeconv.exe ' + CommandLine;
  WinExec(PChar(CommandLine), SW_SHOWNORMAL);
end;

begin
  CreateMutex(nil, False, MutexName);
  with TRegistry.Create do
  begin
    RootKey := HKEY_CURRENT_USER;
    OpenKey(RegPath, True);
    WriteString('Path', ExtractFilePath(ParamStr(0)));
    Free;
  end;
  if ParamCount > 0 then
    WorkWithParams
  else
  begin
    Application.Initialize;
    Application.Title := 'CodeConv 2.7';
  Application.CreateForm(TCodeConvMainForm, CodeConvMainForm);
    Application.CreateForm(TOptionsForm, OptionsForm);
    Application.CreateForm(TEasterEggForm, EasterEggForm);
    Application.Run;
  end;
end.

