{.$DEFINE CodeConvBeta}//Is beta version???
{.$DEFINE WRITELANG}//Write default.ini with language?
unit Main;

interface

uses
  Forms,
  Menus,
  ComCtrls,
  Windows,
  StdCtrls,
  ExtCtrls,
  Buttons,
  Controls,
  Classes,
  LED,
  Gauges,
  CodeConvTools,
  OffBtn,
  Dialogs,
  Translator,
  PBFolderDialog;

type
  TCodeConvMainForm = class (TForm)
    OpenSource: TOpenDialog;
    FromCPCombo: TComboBox;
    CaseGroup: TRadioGroup;
    ToCPCombo: TComboBox;
    OutputFileGroup: TRadioGroup;
    OverwriteCheck: TCheckBox;
    SourceCPLabel: TLabel;
    TargetCPLabel: TLabel;
    StatusText: TStaticText;
    CopyrightText: TStaticText;
    SecretPopupMenu: TPopupMenu;
    EmailItem: TMenuItem;
    ContactItem: TMenuItem;
    RedLED: TLED;
    GreenLED: TLED;
    CodeConvPanel: TPanel;
    MainPanel: TPanel;
    Gauge: TGauge;
    CopyEmailItem: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    CopyUINItem: TMenuItem;
    ICQItem: TMenuItem;
    OptionsButton: TOffice97Button;
    CloseSpeedButton: TSpeedButton;
    MinimizeSpeedButton: TSpeedButton;
    HelpSpeedButton: TSpeedButton;
    DetectButton: TOffice97Button;
    ConvertButton: TOffice97Button;
    DocsButton: TOffice97Button;
    CloseButton: TOffice97Button;
    CRLFCombo: TComboBox;
    TargetEOLLabel: TLabel;
    OpenTarget: TSaveDialog;
    N1: TMenuItem;
    DontAffraidItem: TMenuItem;
    BugsItem: TMenuItem;
    Web1Item: TMenuItem;
    CodeConvItem: TMenuItem;
    CopyWeb1Item: TMenuItem;
    CopyCodeConvURLItem: TMenuItem;
    FileDirGroup: TRadioGroup;
    SubFolderCheck: TCheckBox;
    Translator: TTranslator;
    SelectSourceDir: TPBFolderDialog;
    SelectTargetDir: TPBFolderDialog;
    procedure FormCreate (Sender: TObject);
    procedure OutputFileGroupClick (Sender: TObject);
    procedure ConvertButtonClick (Sender: TObject);
    procedure CloseButtonClick (Sender: TObject);
    procedure OptionsButtonClick (Sender: TObject);
    procedure CodeConvPanelMouseDown (Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CodeConvPanelMouseMove (Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure CodeConvPanelMouseUp (Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CopyrightTextClick (Sender: TObject);
    procedure EmailItemClick (Sender: TObject);
    procedure WebItemClick (Sender: TObject);
    procedure CopyEmailItemClick (Sender: TObject);
    procedure MinimizeButtonClick (Sender: TObject);
    procedure CopyUINItemClick (Sender: TObject);
    procedure HelpButtonClick (Sender: TObject);
    procedure CloseSpeedButtonClick (Sender: TObject);
    procedure HelpSpeedButtonClick (Sender: TObject);
    procedure MinimizeSpeedButtonClick (Sender: TObject);
    procedure DetectButtonClick (Sender: TObject);
    procedure ICQItemClick (Sender: TObject);
    procedure CopyWeb1ItemClick (Sender: TObject);
    procedure CodeConvItemClick (Sender: TObject);
    procedure CopyCodeConvURLItemClick (Sender: TObject);
    procedure FileDirGroupClick (Sender: TObject);
    procedure FormShow (Sender: TObject);
    procedure TranslatorBeforeTranslation (Sender: TObject);
    procedure TranslatorAfterTranslation (Sender: TObject);
    procedure CodeConvPanelDblClick (Sender: TObject);
    procedure FormKeyPress (Sender: TObject; var Key: Char);
    procedure FormMouseWheel (Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
  private
    { Private declarations }
    DragX, DragY: Integer;
    ConvertedSize: Cardinal;
    Title: string;
    ConvertThread: TConvertThread;
    FromCPComboValue,
      CRLFComboValue,
      ToCPComboValue,
      CaseGroupValue,
      FileDirGroupValue,
      OutputFileGroupValue: Integer;
    procedure MakeBusy;
    procedure MakeReady;
    procedure ShowAbout;
    procedure ConvertOneFile (FName1, FName2: string; Cod1, Cod2: TCodePage; Detect, Cas, CRLFs:
      Integer; Msg: string; IsMulti, Total: Cardinal);
  public
    { Public declarations }
  end;

var
  CodeConvMainForm: TCodeConvMainForm;

implementation
uses Options,
  Clipbrd,
  ShellApi,
  SysUtils,
  Registry,
  EasterEgg,
  CommonData;


{$R *.DFM}

function Int2Str (const Number: Integer): string;
var
  S: string;
begin
  Str (Number, S);
  Int2Str := S;
end;

procedure TCodeConvMainForm.FormCreate (Sender: TObject);
//var
//   cp: tCodePage;
var
  Dir: string;
begin
  MakeBusy;
  StatusText.Caption := Translator.TranslateUserMessage ('Initializing', 'Initializing...');
  ToCPCombo.ItemIndex := 1;
  FromCPCombo.ItemIndex := FromCPCombo.Items.Count - 1;
  CRLFCombo.ItemIndex := 1;
  Application.Title := AppName + ' ' + VersionString{$IFDEF CodeConvBeta} + ' beta'{$ENDIF};

  Dir := ExpandFileName (GetCurrentDir + '\');
  if AnsiCompareFileName (Dir, ExtractFilePath (ParamStr (0))) = 0 then
  try
    with TRegistry.Create do
    begin
      RootKey := HKEY_CURRENT_USER;
      OpenKey ('SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders', True);
      Dir := ReadString ('Personal');
      Free;
    end;
  except
    Dir := ExpandFileName (GetCurrentDir);
  end;

  OpenSource.InitialDir := Dir;
  SelectTargetDir.Folder := Dir;
  OpenTarget.InitialDir := Dir;
  SelectSourceDir.Folder := Dir;

  MakeReady;
  StatusText.Caption := Translator.TranslateUserMessage ('Ready', 'Ready...');
end;

procedure TCodeConvMainForm.OutputFileGroupClick (Sender: TObject);
begin
  if OutputFileGroup.ItemIndex = 0 then
  begin
    OverwriteCheck.Enabled := False;
    OverwriteCheck.Checked := False;
  end
  else
  begin
    OverwriteCheck.Enabled := True;
    OverwriteCheck.Checked := True;
  end;
end;

procedure TCodeConvMainForm.ConvertOneFile (FName1, FName2: string; Cod1, Cod2: TCodePage; Detect,
  Cas, CRLFs: Integer; Msg: string; IsMulti, Total: Cardinal);
var
  Save_Cursor: TCursor;
  LastDone, DoneStep, FileSize: Cardinal;
begin
  Save_Cursor := Screen.Cursor;
  Screen.Cursor := crHourglass;
  if (IsMulti = 0) or (ConvertedSize = 0) then
    Title := Application.Title;
  CodeConvMainForm.Refresh;
  if Detect = 1 then
  begin
    StatusText.Caption := Translator.TranslateUserMessage ('Detecting', 'Detecting code page...') + '(' + FName1 + ',' + FName2 + ')';
    Cod1 := DetectCodepage (FName1);
  end;
  StatusText.Caption := Format (Translator.TranslateUserMessage ('Converting', 'Converting file %s'), [Msg]);

  ConvertThread := TConvertThread.Create (nil, nil, FName1, FName2, Cod1, Cod2, TCase (Cas), TEOL (CRLFs));
  ConvertThread.Resume;
  LastDone := 0;
  while ((not (ConvertThread.WasTerminated)) and ((ConvertThread.InputFileSize = 0))) do
    Sleep (10);
  if IsMulti = 0 then Total := ConvertThread.InputFileSize;
  DoneStep := Total div 100;
  while not (ConvertThread.WasTerminated) do
    if ((LastDone + DoneStep) < ConvertThread.CurrentPosition) then
    begin
      LastDone := ConvertThread.CurrentPosition;
      Gauge.Progress := Round (((ConvertedSize + LastDone) / Total) * 100);
      Application.Title := Int2Str (Gauge.Progress) + '% - ' + Title;
    end
    else
      Sleep (10);
  FileSize := ConvertThread.CurrentPosition;
  ConvertedSize := ConvertedSize + FileSize;
  if IsMulti = 0 then
  begin
    Gauge.Progress := 100;
    Application.Title := Title;
    StatusText.Caption := Format (Translator.TranslateUserMessage ('ReadyConvertedOne', 'Ready...(Coverted %d bytes of text from %s code page)'), [FileSize, CodePageNames[Cod1]]);
  end
  else
  begin
    Gauge.Progress := Round ((ConvertedSize / Total) * 100);
    if ConvertedSize = Total then
      Application.Title := Title;
  end;

  ConvertThread.Free;

  Screen.Cursor := Save_Cursor;
end;

procedure TCodeConvMainForm.ConvertButtonClick (Sender: TObject);
var
  Code, Code2: TCodePage;
  I: Integer;
  Det: Integer; //this is not needed, but i'm lazy to remove this...
  All: Integer;
  FileNames: TStringList;
  FilesSize: Cardinal;
  Ext: string;

  procedure BrowseDir (RelName: string);
  var
    SR: TSearchRec;
    f: file of Char;
  begin
    StatusText.Caption := Format (Translator.TranslateUserMessage ('Exploring', 'Exploring directory %s ...'),
      [(SelectSourceDir.Folder + RelName)]);
    FindFirst (SelectSourceDir.Folder + RelName + '*.*', faAnyFile, SR);
    repeat
      if ((SR.Attr and faDirectory) = faDirectory) then
      begin
        if (SR.Name <> '.') and (SR.Name <> '..') then
        begin
          BrowseDir (RelName + SR.Name + '\');
          StatusText.Caption :=
            Format (Translator.TranslateUserMessage ('Exploring', 'Exploring directory %s ...'),
            [(SelectSourceDir.Folder + RelName)]);
        end;
      end
      else
      begin
        Ext := ExtractFileExt (SR.Name);
        Delete (Ext, 1, 1);
        if Pos (Ext, OptTextFileExtensions) > 0 then
        begin
          FileNames.Add (RelName + ExtractFileName (SR.Name));
          AssignFile (f, SelectSourceDir.Folder + RelName + ExtractFileName (SR.Name));
          Reset (f);
          FilesSize := FilesSize + Cardinal (FileSize (f));
          CloseFile (f);
        end;
      end;
    until FindNext (SR) <> 0;
    FindClose (SR);
  end;

begin
  MakeBusy;
  Gauge.ShowText := True;
  Code2 := FirstCodePage;
  for I := 1 to (ToCPCombo.ItemIndex) do
    Code2 := Succ (Code2);
  Code := FirstCodePage;
  for I := 1 to (FromCPCombo.ItemIndex) do
    Code := Succ (Code);
  Det := 0;
  if FromCPCombo.ItemIndex = (FromCPCombo.Items.Count - 1) then
    Det := 1;
  if FileDirGroup.ItemIndex = 1 then
  begin {convert dir}
    StatusText.Caption := Translator.TranslateUserMessage ('SelectSourceDir', 'Select source directory');
    if not SelectSourceDir.Execute then
    begin
      Translator.ShowMessage (Translator.TranslateUserMessage ('ShouldSpecifySourceDir', 'You should specify source diretory!'));
      StatusText.Caption := Translator.TranslateUserMessage ('Ready', 'Ready...');
      MakeReady;
      Gauge.ShowText := False;
      Exit;
    end;

    SelectTargetDir.Folder := SelectSourceDir.Folder;
    SelectSourceDir.Folder := SelectTargetDir.Folder;

    if OutputFileGroup.ItemIndex = 1 then
    begin
      StatusText.Caption := Translator.TranslateUserMessage ('SelectTargetDir', 'Select target directory');
      if not SelectTargetDir.Execute then
      begin
        Translator.ShowMessage (Translator.TranslateUserMessage ('ShouldSpecifyTargetDir', 'You should specify target directory!'#13'Or select Save converted to same file.'));
        StatusText.Caption := Translator.TranslateUserMessage ('Ready', 'Ready...');
        MakeReady;
        Gauge.ShowText := False;
        Exit;
      end;
    end;

    All := 0;
    if (OverwriteCheck.Checked) and (AnsiUpperCase (SelectSourceDir.Folder) =
      AnsiUpperCase (SelectTargetDir.Folder)) then
      if Translator.MessageDlg (
        Format (Translator.TranslateUserMessage ('OverWriteFilesInDir', 'Overwrite files in directory %s?'), [SelectTargetDir.Folder]),
        mtConfirmation, [mbYes, mbNo], 0)
        =
        mrNo then
      begin
        StatusText.Caption := Translator.TranslateUserMessage ('ReadyAborted', 'Ready...(Operation aborted)');
        MakeReady;
        Gauge.ShowText := False;
        Exit;
      end
      else
        All := 1;


    FileNames := TStringList.Create;
    FileNames.Clear;
    FilesSize := 0;
    ConvertedSize := 0;

      {find files}
    BrowseDir ('\');

      {conversion}
    for I := 1 to FileNames.Count do
    begin
      if (OverwriteCheck.Checked) and (FileExists (SelectTargetDir.Folder + '\' +
        ExtractFileName (FileNames[Pred (I)]))) then
      begin
        Gauge.Progress := 0;
        if All = 1 then
          ConvertOneFile (SelectSourceDir.Folder + FileNames[Pred (I)],
            SelectTargetDir.Folder + FileNames[Pred (I)], Code, Code2, Det, CaseGroup.ItemIndex, CRLFCombo.ItemIndex,
            Format (Translator.TranslateUserMessage ('NthFileOf', '%s (file %1:d of %2:d)'), [ExtractFileName (FileNames[Pred (I)]), I, FileNames.Count]), 1, FilesSize)
        else
          case Translator.MessageDlg (
            Format (Translator.TranslateUserMessage ('OverwriteFile', 'Overwrite file %s?'), [SelectTargetDir.Folder + '\' + FileNames[Pred (I)]]),
            mtConfirmation, [mbYes, mbNo, mbAll, mbCancel], 0)
          of
            mrYes:
              ConvertOneFile (SelectSourceDir.Folder + FileNames[Pred (I)],
                SelectTargetDir.Folder + FileNames[Pred (I)], Code, Code2, Det, CaseGroup.ItemIndex, CRLFCombo.ItemIndex,
                Format (Translator.TranslateUserMessage ('NthFileOf', '%s (file %1:d of %2:d)'), [ExtractFileName (FileNames[Pred (I)]), I, FileNames.Count]), 1, FilesSize);
            mrCancel:
              begin
                StatusText.Caption := Translator.TranslateUserMessage ('ReadyAborted', 'Ready...(Operation aborted)');
                MakeReady;
                Gauge.ShowText := False;
                Exit;
              end;
            mrAll:
              begin
                All := 1;
                ConvertOneFile (SelectSourceDir.Folder + FileNames[Pred (I)],
                  SelectTargetDir.Folder + FileNames[Pred (I)], Code, Code2, Det, CaseGroup.ItemIndex, CRLFCombo.ItemIndex,
                  Format (Translator.TranslateUserMessage ('NthFileOf', '%s (file %1:d of %2:d)'), [ExtractFileName (FileNames[Pred (I)]), I, FileNames.Count]), 1, FilesSize);
              end;
          end;
      end
      else
        ConvertOneFile (SelectSourceDir.Folder + FileNames[Pred (I)],
          SelectTargetDir.Folder + FileNames[Pred (I)], Code, Code2, Det,
          CaseGroup.ItemIndex, CRLFCombo.ItemIndex,
          Format (Translator.TranslateUserMessage ('NthFileOf', '%s (file %1:d of %2:d)'),
          [ExtractFileName (FileNames[Pred (I)]), I, FileNames.Count]), 1, FilesSize);
    end;
      {conversions ends}


    StatusText.Caption := Format (Translator.TranslateUserMessage ('ReadyConvertedFiles', 'Ready...(Coverted %d files)'),
      [FileNames.Count]);

    ConvertedSize := 0;

    Gauge.ShowText := False;
    Gauge.Progress := 0;
    MakeReady;
  end {convert dir}
  else
  begin {convert files}
    OpenSource.Title := Translator.TranslateUserMessage ('SelectSourceFiles', 'Select source file(s)');
    StatusText.Caption := OpenSource.Title;
    if OpenSource.Execute then
    begin
      if OpenSource.Files.Count = 1 then
      begin
        if OutputFileGroup.ItemIndex = 0 then
          OpenTarget.FileName := OpenSource.FileName
        else
        begin
          StatusText.Caption := Translator.TranslateUserMessage ('SelectTargetFile', 'Select target file');
          OpenTarget.Title := StatusText.Caption;
          if not (OpenTarget.Execute) then
          begin
            Translator.ShowMessage (Translator.TranslateUserMessage ('ShouldSpecifyTargetFile', 'You should specify target file!'#13'Or select Save converted to same file.'));
            StatusText.Caption := Translator.TranslateUserMessage ('Ready', 'Ready...');
            MakeReady;
            Gauge.ShowText := False;
            Exit;
          end;
          if (OverwriteCheck.Checked) and (FileExists (OpenTarget.FileName)) then
            if Translator.MessageDlg (
              Format (Translator.TranslateUserMessage ('OverwriteFile', 'Overwrite file %s ?'), [OpenTarget.FileName]),
              mtConfirmation, [mbYes, mbNo], 0)
              =
              mrNo then
            begin
              StatusText.Caption := Translator.TranslateUserMessage ('ReadyAborted', 'Ready...(Operation aborted)');
              MakeReady;
              Gauge.ShowText := False;
              Exit;
            end;
        end;
        ConvertOneFile (OpenSource.FileName, OpenTarget.FileName, Code, Code2, Det, CaseGroup.ItemIndex, CRLFCombo.ItemIndex, ExtractFileName (OpenSource.FileName), 0, 0);
      end
      else
      begin
      //convert multiple files
        if OutputFileGroup.ItemIndex = 0 then
        begin
          for I := 1 to OpenSource.Files.Count do
            ConvertOneFile (OpenSource.Files[Pred (I)], OpenSource.Files[Pred (I)], Code, Code2, Det, CaseGroup.ItemIndex, CRLFCombo.ItemIndex,
              Format (Translator.TranslateUserMessage ('NthFileOf', '%s (file %1:d of %2:d)'), [ExtractFileName (OpenSource.Files[Pred (I)]), I, OpenSource.Files.Count]), 0, 0);
        end
        else
        begin
          StatusText.Caption := Translator.TranslateUserMessage ('SelectTargetDir', 'Select target directory');
          if not (SelectTargetDir.Execute) then
          begin
            Translator.ShowMessage (Translator.TranslateUserMessage ('ShouldSpecifyTargetDir', 'You should specify target directory!'#13'Or select Save converted to same file'));
            StatusText.Caption := Translator.TranslateUserMessage ('ReadyAborted', 'Ready...(Operation aborted))');
            MakeReady;
            Gauge.ShowText := False;
            Exit;
          end;
          All := 0;
          for I := 1 to OpenSource.Files.Count do
          begin
            if (OverwriteCheck.Checked) and (FileExists (SelectTargetDir.Folder + '\' +
              ExtractFileName (OpenSource.Files[Pred (I)]))) then
            begin
              Gauge.Progress := 0;
              if All = 1 then
                ConvertOneFile (OpenSource.Files[Pred (I)], SelectTargetDir.Folder + '\' + ExtractFileName (OpenSource.Files[Pred (I)]), Code, Code2, Det, CaseGroup.ItemIndex, CRLFCombo.ItemIndex,
                  Format (Translator.TranslateUserMessage ('NthFileOf', '%s (file %1:d of %2:d)'), [ExtractFileName (OpenSource.Files[Pred (I)]), I, OpenSource.Files.Count]), 0, 0)
              else
                case Translator.MessageDlg (
                  Format (Translator.TranslateUserMessage ('OverwriteFile', 'Overwrite file %s ?'), [SelectTargetDir.Folder + '\' + ExtractFileName (OpenSource.Files[Pred (I)])]),
                  mtConfirmation, [mbYes, mbNo, mbAll, mbCancel], 0)
                of
                  mrYes:
                    ConvertOneFile (OpenSource.Files[Pred (I)], SelectTargetDir.Folder + '\' + ExtractFileName (OpenSource.Files[Pred (I)]), Code, Code2, Det, CaseGroup.ItemIndex, CRLFCombo.ItemIndex,
                      Format (Translator.TranslateUserMessage ('NthFileOf', '%s (file %1:d of %2:d)'), [ExtractFileName (OpenSource.Files[Pred (I)]), I, OpenSource.Files.Count]), 0, 0);
                  mrCancel:
                    begin
                      StatusText.Caption := Translator.TranslateUserMessage ('ReadyAborted', 'Ready...(Operation aborted)');
                      MakeReady;
                      Gauge.ShowText := False;
                      Exit;
                    end;
                  mrAll:
                    begin
                      All := 1;
                      ConvertOneFile (OpenSource.Files[Pred (I)], SelectTargetDir.Folder + '\' + ExtractFileName (OpenSource.Files[Pred (I)]), Code, Code2, Det, CaseGroup.ItemIndex, CRLFCombo.ItemIndex,
                        Format (Translator.TranslateUserMessage ('NthFileOf', '%s (file %1:d of %2:d)'), [ExtractFileName (OpenSource.Files[Pred (I)]), I, OpenSource.Files.Count]), 0, 0);
                    end;
                end;
            end
            else
              ConvertOneFile (OpenSource.Files[Pred (I)], SelectTargetDir.Folder + '\' + ExtractFileName (OpenSource.Files[Pred (I)]), Code, Code2, Det, CaseGroup.ItemIndex, CRLFCombo.ItemIndex,
                Format (Translator.TranslateUserMessage ('NthFileOf', '%s (file %1:d of %2:d)'), [ExtractFileName (OpenSource.Files[Pred (I)]), I, OpenSource.Files.Count]), 0, 0);
          end;
        end;
        StatusText.Caption :=
          Format (Translator.TranslateUserMessage ('ReadyConvertedFiles', 'Ready...(Coverted %d files)'),
          [OpenSource.Files.Count]);
      end;
    end
    else
    begin
      Translator.ShowMessage (Translator.TranslateUserMessage ('ShouldSpecifySourceFile', 'You should specify source file(s)!'));
      StatusText.Caption :=
        Translator.TranslateUserMessage ('ReadyAborted', 'Ready...(Operation aborted))');
    end;

    Gauge.ShowText := False;
    Gauge.Progress := 0;
    MakeReady;
  end; {convert files}
end;

procedure TCodeConvMainForm.CloseButtonClick (Sender: TObject);
begin
  MakeBusy;
  CodeConvMainForm.Close;
end;

procedure TCodeConvMainForm.OptionsButtonClick (Sender: TObject);
begin
  OptionsForm.ShowModal;
end;

procedure TCodeConvMainForm.MakeBusy;
begin
  RedLED.Lit := True;
  GreenLED.Lit := False;
end;

procedure TCodeConvMainForm.MakeReady;
begin
  RedLED.Lit := False;
  GreenLED.Lit := True;
end;

procedure TCodeConvMainForm.CodeConvPanelMouseDown (Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  DragX := X;
  DragY := Y;
end;

procedure TCodeConvMainForm.CodeConvPanelMouseMove (Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
const
  Even: Boolean = True;
begin
  Even := not (Even);
  if Even and (ssLeft in Shift) then
  begin
    Top := Top + (Y - DragY);
    Left := Left + (X - DragX);
  end;
end;

procedure TCodeConvMainForm.CodeConvPanelMouseUp (Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  DragX := 0;
  DragY := 0;
end;

procedure TCodeConvMainForm.CopyrightTextClick (Sender: TObject);
begin
  ShellExecute (ValidParentForm (Self).Handle, 'open', PChar (AuthorWeb), nil, nil,
    SW_SHOWNORMAL);
end;

procedure TCodeConvMainForm.EmailItemClick (Sender: TObject);
begin
  ShellExecute (ValidParentForm (Self).Handle, 'open', PChar ('mailto:' + AuthorEmail), nil, nil,
    SW_SHOWNORMAL);
end;

procedure TCodeConvMainForm.WebItemClick (Sender: TObject);
begin
  ShellExecute (ValidParentForm (Self).Handle, 'open', PChar (AuthorWeb), nil, nil,
    SW_SHOWNORMAL);
end;

procedure TCodeConvMainForm.CopyEmailItemClick (Sender: TObject);
begin
  Clipboard.SetTextBuf (PChar (AuthorEmail));
end;


procedure TCodeConvMainForm.MinimizeButtonClick (Sender: TObject);
begin
  Application.Minimize;
end;

procedure TCodeConvMainForm.CopyUINItemClick (Sender: TObject);
begin
  Clipboard.SetTextBuf (PChar (AuthorUIN));
end;

procedure TCodeConvMainForm.HelpButtonClick (Sender: TObject);
begin
  if FileExists (ExtractFilePath (ParamStr (0)) + 'Manual\index.html') then
    ShellExecute (ValidParentForm (Self).Handle, 'open', PChar ('Manual\index.html'), PChar (''),
      nil,
      SW_SHOWNORMAL)
  else
    Translator.ShowMessage (
      Translator.TranslateUserMessage ('ManualNotFound', 'Sorry manual not found. You haven''t probably installed it.'));
end;


procedure TCodeConvMainForm.CloseSpeedButtonClick (Sender: TObject);
begin
  MakeBusy;
  CodeConvMainForm.Close;
end;

procedure TCodeConvMainForm.ShowAbout;
begin
  MakeBusy;
  StatusText.Caption := '';
  Translator.ShowMessage (AppName + ' ' + Translator.TranslateUserMessage ('Version', 'version') +
    ' ' + VersionString + ' '{$IFDEF CodeConvBeta} + 'BETA'{$ENDIF} + #13 +
    AppCopyright + #13 +
    '' + #13 +
{$IFDEF CodeConvBeta}
    Translator.TranslateUserMessage ('BetaVarning', 'This is development version and as development version this may' + #13 +
    'contain serious bugs!') + #13 +
    '' + #13 +
{$ENDIF}
    Translator.TranslateUserMessage ('FreewareAndDisclaimer', 'This program is freeware and author is not responsible for'
    + #13 +
    'any bad things that this program causes.') + #13 +
    '' + #13 +
    Translator.TranslateUserMessage ('ProgramDescription', 'This program can convert almost any code pages used for' +
    #13 +
    'Czech or Slovak text files. If you thing there is any code' + #13 +
    'page missing, please contact me. I hope this program will' + #13 +
    'support all (thousands??? :o)) czech code pages.') + #13 +
    '' + #13 +
    Translator.TranslateUserMessage ('UsedComponents', 'This program uses some free components:' + #13 +
    '' + #13 +
    ' Office 97 Assistant style button written by Jonathan Hosking' + #13 +
    '' + #13 +
    ' TLED V1.1 Copyright  1997, Gary Hardman.' + #13 +
    '' + #13 +
    ' TCheckedComboBox Ver 1.0 by Tsourinakis Antonis' + #13 +
    '' + #13 +
    'Conversion is done by CodeConvTools unit which is freely downloadable' + #13 +
    'on my web site. Translation to other languages is done by Translator,' + #13 +
    'which is also freely downloadable on my web site.') + #13 +
    '' + #13 +
    Translator.TranslateUserMessage ('AuthorsEmail', 'Authors email:') + ' ' + AuthorEmail + #13 +
    Translator.TranslateUserMessage ('AuthorsWeb', 'Authors web site:') + ' ' + AuthorWeb + #13 +
    Translator.TranslateUserMessage ('EasyAccess', '(You can easily use these links in right bottom corner of main window)') + #13 +
    Translator.TranslateUserMessage ('TranslationNote', '')
    );
  MakeReady;
  StatusText.Caption := Translator.TranslateUserMessage ('Ready', 'Ready...');
end;

procedure TCodeConvMainForm.HelpSpeedButtonClick (Sender: TObject);
begin
  ShowAbout;
end;

procedure TCodeConvMainForm.MinimizeSpeedButtonClick (Sender: TObject);
begin
  Application.Minimize;
end;

procedure TCodeConvMainForm.DetectButtonClick (Sender: TObject);
var
  Code: TCodePage;
begin
  MakeBusy;
  OpenSource.Title := Translator.TranslateUserMessage ('SelectFileDetect', 'Select file to detect code page');

  StatusText.Caption := OpenSource.Title;
  if OpenSource.Execute then
  begin
    StatusText.Caption := Translator.TranslateUserMessage ('Detecting', 'Detecting code page...');
    Code := DetectCodepage (OpenSource.FileName);
    StatusText.Caption := Format (Translator.TranslateUserMessage ('Detected', 'Detected code page: %s'),
      [CodePageNames[Code]]);
  end
  else
    StatusText.Caption := Translator.TranslateUserMessage ('Ready', 'Ready...');
  MakeReady;
end;

procedure TCodeConvMainForm.ICQItemClick (Sender: TObject);
begin
  Translator.ShowMessage ('ICQ UIN: ' + AuthorUIN);
end;

procedure TCodeConvMainForm.CopyWeb1ItemClick (Sender: TObject);
begin
  Clipboard.SetTextBuf (PChar (AuthorWeb));
end;

procedure TCodeConvMainForm.CodeConvItemClick (Sender: TObject);
begin
  ShellExecute (ValidParentForm (Self).Handle, 'open', PChar (ProgramWeb), nil, nil, SW_SHOWNORMAL);
end;

procedure TCodeConvMainForm.CopyCodeConvURLItemClick (Sender: TObject);
begin
  Clipboard.SetTextBuf (PChar (ProgramWeb));
end;

procedure TCodeConvMainForm.FileDirGroupClick (Sender: TObject);
begin
  if FileDirGroup.ItemIndex = 0 then
  begin
    SubFolderCheck.Enabled := False;
    SubFolderCheck.Checked := False;
  end
  else
  begin
    SubFolderCheck.Enabled := True;
    SubFolderCheck.Checked := True;
  end;
end;

procedure TCodeConvMainForm.FormShow (Sender: TObject);
begin
  with TRegistry.Create do
  begin
    RootKey := HKEY_CURRENT_USER;
    OpenKey (RegPath, True);
    WriteString ('Path', ExtractFilePath (ParamStr (0)));
    Free;
  end;

  Translator.RootComponent := Application;
  Translator.UseEmpty := False;
  Translator.AddRootName := False;
{$IFDEF WRITELANG}

  Translator.LanguageFile := ExtractFilePath (ParamStr (0)) + DefaultLanguageFile;
  Translator.CreateIniFile;

{$ENDIF}
  if FileExists (ExtractFilePath (ParamStr (0)) + LanguageFile) then
  begin
    Translator.LanguageFile := ExtractFilePath (ParamStr (0)) + LanguageFile;
    Translator.Translate;
  end;
  StatusText.Caption := Translator.TranslateUserMessage ('Ready', 'Ready...');
  ToCPCombo.SetFocus;
end;

procedure TCodeConvMainForm.TranslatorBeforeTranslation (Sender: TObject);
begin
  FromCPComboValue := FromCPCombo.ItemIndex;
  CRLFComboValue := CRLFCombo.ItemIndex;
  ToCPComboValue := ToCPCombo.ItemIndex;
  CaseGroupValue := CaseGroup.ItemIndex;
  FileDirGroupValue := FileDirGroup.ItemIndex;
  OutputFileGroupValue := OutputFileGroup.ItemIndex;
end;

procedure TCodeConvMainForm.TranslatorAfterTranslation (Sender: TObject);
var
  CP: TCodePage;
begin
  FromCPCombo.ItemIndex := FromCPComboValue;
  CRLFCombo.ItemIndex := CRLFComboValue;
  ToCPCombo.ItemIndex := ToCPComboValue;
  CaseGroup.ItemIndex := CaseGroupValue;
  FileDirGroup.ItemIndex := FileDirGroupValue;
  OutputFileGroup.ItemIndex := OutputFileGroupValue;

  EasterEggForm.TranslMemo.Clear;
  for CP := cp895 to cpAscii do
    EasterEggForm.TranslMemo.Lines.Add(MakeLen (CodeConvMainForm.ToCPCombo.Items[Ord (CP)],
      28) + #9 + ConvertString (EasterEggForm.TextEdit.Text, cp1250, CP, CaseNoChange));

  for CP := FirstCodePage to Pred (cpAny) do
    OptionsForm.TargetCpsChecks[CP].Caption := CodeConvMainForm.ToCPCombo.Items[Integer (CP)];

end;

procedure TCodeConvMainForm.CodeConvPanelDblClick (Sender: TObject);
begin
  EasterEggForm.ShowModal;
end;

procedure TCodeConvMainForm.FormKeyPress (Sender: TObject; var Key: Char);
begin
  if Key = #13 then ConvertButtonClick (Sender);
end;

procedure TCodeConvMainForm.FormMouseWheel (Sender: TObject;
  Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint;
  var Handled: Boolean);
begin
  MousePos := MainPanel.ScreenToClient (MousePos);
  if (MousePos.Y > ToCPCombo.BoundsRect.Top) and
    (MousePos.Y < ToCPCombo.BoundsRect.Bottom) and
    (MousePos.X > ToCPCombo.BoundsRect.Left) and
    (MousePos.X < ToCPCombo.BoundsRect.Right) then
  begin
    if WheelDelta < 0 then
    begin
      if ToCPCombo.ItemIndex < ToCPCombo.Items.Count then
        ToCPCombo.ItemIndex := ToCPCombo.ItemIndex + 1;
    end
    else
      if ToCPCombo.ItemIndex > 0 then
        ToCPCombo.ItemIndex := ToCPCombo.ItemIndex - 1;
    begin
    end;
    Handled := True;
  end
  else
    if (MousePos.Y > FromCPCombo.BoundsRect.Top) and
      (MousePos.Y < FromCPCombo.BoundsRect.Bottom) and
      (MousePos.X > FromCPCombo.BoundsRect.Left) and
      (MousePos.X < FromCPCombo.BoundsRect.Right) then
    begin
      if WheelDelta < 0 then
      begin
        if FromCPCombo.ItemIndex < FromCPCombo.Items.Count then
          FromCPCombo.ItemIndex := FromCPCombo.ItemIndex + 1;
      end
      else
        if FromCPCombo.ItemIndex > 0 then
          FromCPCombo.ItemIndex := FromCPCombo.ItemIndex - 1;
      begin
      end;
      Handled := True;
    end
    else
      if (MousePos.Y > CaseGroup.BoundsRect.Top) and
        (MousePos.Y < CaseGroup.BoundsRect.Bottom) and
        (MousePos.X > CaseGroup.BoundsRect.Left) and
        (MousePos.X < CaseGroup.BoundsRect.Right) then
      begin
        if WheelDelta < 0 then
        begin
          if CaseGroup.ItemIndex < CaseGroup.Items.Count then
            CaseGroup.ItemIndex := CaseGroup.ItemIndex + 1;
        end
        else
          if CaseGroup.ItemIndex > 0 then
            CaseGroup.ItemIndex := CaseGroup.ItemIndex - 1;
        begin
        end;
        Handled := True;
      end
      else
        if (MousePos.Y > CRLFCombo.BoundsRect.Top) and
          (MousePos.Y < CRLFCombo.BoundsRect.Bottom) and
          (MousePos.X > CRLFCombo.BoundsRect.Left) and
          (MousePos.X < CRLFCombo.BoundsRect.Right) then
        begin
          if WheelDelta < 0 then
          begin
            if CRLFCombo.ItemIndex < CRLFCombo.Items.Count then
              CRLFCombo.ItemIndex := CRLFCombo.ItemIndex + 1;
          end
          else
            if CRLFCombo.ItemIndex > 0 then
              CRLFCombo.ItemIndex := CRLFCombo.ItemIndex - 1;
          begin
          end;
          Handled := True;
        end
        else
          if (MousePos.Y > FileDirGroup.BoundsRect.Top) and
            (MousePos.Y < FileDirGroup.BoundsRect.Bottom) and
            (MousePos.X > FileDirGroup.BoundsRect.Left) and
            (MousePos.X < FileDirGroup.BoundsRect.Right) then
          begin
            if WheelDelta < 0 then
            begin
              if FileDirGroup.ItemIndex < FileDirGroup.Items.Count then
                FileDirGroup.ItemIndex := FileDirGroup.ItemIndex + 1;
            end
            else
              if FileDirGroup.ItemIndex > 0 then
                FileDirGroup.ItemIndex := FileDirGroup.ItemIndex - 1;
            begin
            end;
            Handled := True;
          end
          else
            if (MousePos.Y > OutputFileGroup.BoundsRect.Top) and
              (MousePos.Y < OutputFileGroup.BoundsRect.Bottom) and
              (MousePos.X > OutputFileGroup.BoundsRect.Left) and
              (MousePos.X < OutputFileGroup.BoundsRect.Right) then
            begin
              if WheelDelta < 0 then
              begin
                if OutputFileGroup.ItemIndex < OutputFileGroup.Items.Count then
                  OutputFileGroup.ItemIndex := OutputFileGroup.ItemIndex + 1;
              end
              else
                if OutputFileGroup.ItemIndex > 0 then
                  OutputFileGroup.ItemIndex := OutputFileGroup.ItemIndex - 1;
              begin
              end;
              Handled := True;
            end
            else
              Handled := False;
end;

end.

